#ifndef IETRACES_H
#define IETRACES_H 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdint.h>

#ifdef WORDS_BIGENDIAN
#define LE16_TO_CPU(a) ((((a) & 0xFF) << 8) | ((a) >> 8))
#define LE32_TO_CPU(a) ((LE16_TO_CPU((a) & 0xFFFF) << 16) | \
     LE16_TO_CPU((a) >> 16))
#define LE64_TO_CPU(a) ((LE32_TO_CPU((a) & 0xFFFFFFFF)<< 32) | \
     LE32_TO_CPU((a) >> 32))
#else /* WORDS_BIGENDIAN */
#define LE16_TO_CPU(a) (a)
#define LE32_TO_CPU(a) (a)
#define LE64_TO_CPU(a) (a)
#endif /* WORDS_BIGENDIAN */

#define GET_U32(a) ((uint32_t)LE32_TO_CPU(*(uint32_t *)(a)))
#define GET_U64(a) ((uint64_t)LE64_TO_CPU(*(uint64_t *)(a)))

/*#define IS_MAGIC(a, b) ((*(uint32_t *)(a)) == GET_U32(b))

#define IS_URL(a, b) IS_MAGIC((a), "URL ")
#define IS_LEAK(a, b) IS_MAGIC((a), "LEAK")
#define IS_REDR(a, b) IS_MAGIC((a), "REDR")*/

#define URL_TYPE (*(uint32_t *)("URL "))
#define LEAK_TYPE (*(uint32_t *)("LEAK"))
#define REDR_TYPE (*(uint32_t *)("REDR"))

#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif

#endif /* IETRACES_H */
